﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.Emit;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using TMcraft;
using EasyModbus;
using System.IO;

using Newtonsoft.Json;
using System.Data;
using System.Diagnostics;
using System.Collections.ObjectModel;
using System.IO.Pipes;
using System.Net.Http.Json;
using System.Windows.Ink;
using System.Data.Common;



namespace Toolbar1
{
    public partial class MainPage : UserControl, ITMcraftToolbarEntry
    {

        #region Definition for parameters on the table
        int iTimeFWait = 0;
        int iTimeRWait = 0;
        int iTimeEWait = 0;
        int iTimePWait = 0;
        int iTimeStopWait = 0;

        float fRuntime = 0;
        float fDowntime = 0;
        float fRuntimeRate = 0;
        float fDowntimeRate = 0;
        int iPassQuantity = 0;
        int iCycleQuantity = 0;

        bool bResultError = false;
        bool bResultEstop = false;
        bool bResultRun = false;
        bool bResultPause = false;
        bool status_CDO0 = false;
        bool bCurrentSensor1 = false;
        bool bLastSensor1 = false;
        bool bCurrentSensor2 = false;
        bool bLastSensor2 = false;
        bool bCurrentSensor3 = false;
        bool bLastSensor3 = false;
        bool bCurrentSensor4 = false;
        bool bLastSensor4 = false;
        bool bPassRestCheck = false;

        
        int iResultOperation = 0;
        float fYieldRate = 0;
        int iCountSensor1 = 0;
        int iCountSensor4 = 0;
        float fFPY = 0;
        bool bFTPBegin = false;
        bool bPPTBegin = false;
        int iFPTtime = 0;
        int iPPTtime = 0;
        int iHourIndex = 0;
        int iUtilizeRateHours = 0;
        float fUtilizeRate = 0;
        int[] errorcode = new int[2];
        int[] errorcodeUsign = new int[2];
        string sRobotErrorCode = "";      
        bool bSensor1_DI = false;
        bool bSensor2_DI = false;
        bool bSensor3_DI = false;   
        bool bSensor4_DI = false;

        int ig_Variable1 = 0;
        int ig_Variable2 = 0;
        int ig_Variable3 = 0;
        int ig_Variable4 = 0;
        int ig_Variable5 = 0;
        int iCurrentReset = 0;
        int iLastReset = 0;

        
        #endregion


        #region JSON檔案相關
        static string jsonSettingFile = @"..\..\..\TextFiles\Modbus_Configurator_Setting.txt";
        static string jsonFilePath1 = @"..\..\..\TextFiles\Modbus_Configurator_Table1.txt";
        static string jsonFilePath2 = @"..\..\..\TextFiles\Modbus_Configurator_Table2.txt";
        static string jsonFilePath3 = @"..\..\..\TextFiles\Modbus_Configurator_Table3.txt";
        static string jsonFilePath4 = @"..\..\..\TextFiles\Modbus_Configurator_Table4.txt";
        static string jsonFilePath5 = @"..\..\..\TextFiles\Modbus_Configurator_Table5.txt";
        static string jsonFileCurrent = "";
        static string jsonFilePath_Output = @"..\..\..\TextFiles\Modbus_Configurator_Setting_LastSaved.txt";
        #endregion

        #region Table相關
        int iTableIndex = 0;
        public ObservableCollection<string> TypeOptions { get; private set; }
        private DataTable dataTable = new DataTable();
        MyJsonObject myObject = new MyJsonObject();
        SettingFileJsonObject SettingFileObject = new SettingFileJsonObject();
        #endregion

        #region 其餘元件
        TMcraftToolbarAPI ToolbarUI = new TMcraftToolbarAPI();
        private DispatcherTimer timer;
        private DispatcherTimer timer2;
        ModbusClient modbusClient = new ModbusClient();
        #endregion

        #region 初始化
        public void InitializeToolbar(TMcraftToolbarAPI _toolbarUI)
        {
            ToolbarUI = _toolbarUI;
        }
        private void UserControl_Loaded(object sender, EventArgs e)
        {
            try
            {
                modbusClient = new ModbusClient("127.0.0.1", 502);
                modbusClient.Connect();
                if (ToolbarUI == null || ToolbarUI.RobotStatusProvider == null)
                {
                    textBox.Text = $"Toolbar Error...";
                }
                else
                {
                    ToolbarUI.IOProvider.ReadDigitOutput(IO_TYPE.CONTROL_BOX, 0, 0, out status_CDO0);
                }

            }
            catch (Exception ex)
            {
                textBox.Text = $"Other error, ${ex.Message}";
            }
        }
        public MainPage()
        {
            InitializeComponent();
            TypeOptions = new ObservableCollection<string>();

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromMilliseconds(1000);
            timer.Tick += Timer_Tick;

            timer2 = new DispatcherTimer();
            timer2.Interval = TimeSpan.FromMilliseconds(200);
            timer2.Tick += Timer2_Tick;
          
            timer.Start();
            timer2.Start();
            Window ThisWindow = (Window)Application.Current.MainWindow;
            ThisWindow.Topmost = true;
            ThisWindow.Closing += ThisWindow_Closing;
            UpdateSettingValue();
            Table2_Initialization();
        }

        private void ThisWindow_Closing(object? sender, System.ComponentModel.CancelEventArgs e)
        {
        }
            #region JSON檔案相關
                public class SettingFileJsonObject
                {
                    public int Selected { get; set; }
                }


                public class MyJsonObject
                {
                    public string? Comment { get; set; }
                    public Variable[] Variables { get; set; } = Array.Empty<Variable>();
                    public Signal[] Signal { get; set; } = Array.Empty<Signal>();
                }



                public class Variable
                {
                    public int Sequence { get; set; }
                    public string Name { get; set; }
                    public int StartAddress { get; set; }
                    public int Length { get; set; }
                    public string Type { get; set; }
                    public int DI { get; set; }

                    public Variable()
                    {
                        Sequence = 0;
                        Name = "";
                        StartAddress = 0;
                        Length = 0;
                        Type = ""; // 提供初始值
                        DI = 0;
                    }
                }
                public class Signal
                {
                    public string Name { get; set; }
                    public string Trigger { get; set; }
                    public int DI { get; set; }
                    public int FilterTime { get; set; }

                    public Signal()
                    {
                        Name = "Sensor1";
                        Trigger = "Raise";
                        DI = 0;
                        FilterTime = 200;
                    }
                }
        #endregion

        #endregion

        #region 刷新功能相關
        //每秒Timer
        private void Timer_Tick(object? sender, EventArgs e)
        {
            ReadRobotStatus();

            if (checkBox_AutoRead.IsChecked == true)
            {
                dataGrid.IsEnabled = false;
                UpdateTable1();
                comboBox_TableSelect.IsEnabled = false;
                button_Save.IsEnabled = false;
                button_Restore.IsEnabled = false;
                comboBox_HoursSelect.IsEnabled = false;                
                dataGrid1.IsEnabled = false;
                checkBox_Sensor1.IsEnabled = false;
                checkBox_Sensor2.IsEnabled = false;
                checkBox_Sensor3.IsEnabled = false;
                checkBox_Sensor4.IsEnabled = false;
            }
            else
            {
                dataGrid.IsEnabled = true;
                comboBox_TableSelect.IsEnabled = true;
                button_Save.IsEnabled = true;
                button_Restore.IsEnabled = true;
                comboBox_HoursSelect.IsEnabled = true;
                dataGrid1.IsEnabled = true;
                checkBox_Sensor1.IsEnabled = false;
                checkBox_Sensor2.IsEnabled = false;
                checkBox_Sensor3.IsEnabled = false;  
                checkBox_Sensor4.IsEnabled = false;
            }

            bLastSensor1 = bCurrentSensor1;
            bLastSensor2 = bCurrentSensor2;
            bLastSensor3 = bCurrentSensor3;
            bLastSensor4 = bCurrentSensor4;
        }

        private  void Timer2_Tick(object? sender, EventArgs e)
        {

            
            
            //Get dataGrid1 row value
            DataRowView dataGrid1_row = (DataRowView)dataGrid1.Items[0];
            DataRowView dataGrid1_row1 = (DataRowView)dataGrid1.Items[1];
            DataRowView dataGrid1_row2 = (DataRowView)dataGrid1.Items[2];
            DataRowView dataGrid1_row3 = (DataRowView)dataGrid1.Items[3];
            
            if (ToolbarUI.IOProvider == null)
            {
                return;
            }
            try 
            {
                ToolbarUI.IOProvider.ReadDigitInput(IO_TYPE.CONTROL_BOX, 0, (int)dataGrid1_row["DI"], out bSensor1_DI);
                ToolbarUI.IOProvider.ReadDigitInput(IO_TYPE.CONTROL_BOX, 0, (int)dataGrid1_row1["DI"], out bSensor2_DI);
                ToolbarUI.IOProvider.ReadDigitInput(IO_TYPE.CONTROL_BOX, 0, (int)dataGrid1_row2["DI"], out bSensor3_DI);
                ToolbarUI.IOProvider.ReadDigitInput(IO_TYPE.CONTROL_BOX, 0, (int)dataGrid1_row3["DI"], out bSensor4_DI);
                
            }
            catch (Exception ex)
            {
                textBox.Text = $"Error occurred: {ex.Message}";
            }
        

        }
        

        void ReadRobotStatus()
        {

            bPassRestCheck = false;
            if (ToolbarUI.RobotStatusProvider == null)
            {
                return;
            }

            try
            {
                checkBox_Sensor1.IsChecked = bSensor1_DI;
                checkBox_Sensor2.IsChecked = bSensor2_DI;
                checkBox_Sensor3.IsChecked = bSensor3_DI;
                checkBox_Sensor4.IsChecked = bSensor4_DI;


                ToolbarUI.RobotStatusProvider.GetOperationMode(out iResultOperation); // 0:Manual  1:auto
                ToolbarUI.RobotStatusProvider.RobotErrorOrNot(out bResultError);
                ToolbarUI.RobotStatusProvider.RobotEstopOrNot(out bResultEstop);
                ToolbarUI.RobotStatusProvider.ProjectRunOrNot(out bResultRun);
                ToolbarUI.RobotStatusProvider.ProjectPauseOrNot(out bResultPause);

                

                if ((bResultError == true) || (bResultEstop == true)) //If error occured
                {
                    iTimeEWait++;
                    if (iTimeEWait > 100)
                    {
                        iTimeEWait = 100;
                    }

                    // read Error code :FC:04/Address 7320~7321 int32 -->last error code
                    errorcode = modbusClient.ReadInputRegisters(7320, 2);
                    for (int j = 0; j < errorcode.Length; j++)
                    {
                        errorcodeUsign[j] = (ushort)(errorcode[j]);
                    }

                    sRobotErrorCode = (errorcodeUsign[0] * 65536 + errorcodeUsign[1]).ToString("X").PadLeft(8, '0');                   
                    bPassRestCheck = true;
                }
                else if (bResultRun == false) //If stopped
                {
                    iTimeStopWait++;
                    if (iTimeStopWait > 100)
                    {
                        iTimeStopWait = 100;
                    }
                    bPassRestCheck = true;
                    sRobotErrorCode = "00000000";
                }
                else if (bResultPause == true) //If paused
                {
                    iTimePWait++;
                    if (iTimePWait > 100)
                    {
                        iTimePWait = 100;
                    }
                    bPassRestCheck = true;
                    sRobotErrorCode = "00000000";
                }
                else //Normal running
                {
                    fRuntime = fRuntime + 1;
                    if (fRuntime > 10000)
                    {
                        fRuntime = 10000;
                    }
                    sRobotErrorCode = "00000000";
                }

                if (bPassRestCheck == false)      
                {
                    if (checkBox_Sensor1.IsChecked.HasValue)
                    {
                        bCurrentSensor1 = checkBox_Sensor1.IsChecked.Value;

                        if (bCurrentSensor1 == false && bLastSensor1 == true)
                        {
                            iTimeFWait = 0;
                        }
                        if (bCurrentSensor1 == false)
                        {
                            iTimeFWait++;
                            if (iTimeFWait > 100)
                            {
                                iTimeFWait = 100;
                            }
                        }
                        if (bCurrentSensor1 == true && bLastSensor1 == false)
                        {
                            iCountSensor1 = iCountSensor1 + 1;
                            if(iCountSensor1 > 10000)
                            {
                                iCountSensor1 = 10000;
                            }
                            bFTPBegin = true; //start to calculate time between sensor1 and sensor2   
                            iFPTtime = 0; 
                        }
                    }

                    if (checkBox_Sensor2.IsChecked.HasValue)
                    {
                        bCurrentSensor2 = checkBox_Sensor2.IsChecked.Value;
                        if (bCurrentSensor2 == true && bLastSensor2 == false)
                        {
                            bFTPBegin = false;
                        }
                        else 
                        {
                            if(bFTPBegin == true)
                            {
                                iFPTtime = iFPTtime + 1;
                                if(iFPTtime > 100) 
                                {
                                    iFPTtime = 100;
                                }
                            }
                        }
                    }
                    

                    if (checkBox_Sensor3.IsChecked.HasValue)
                    {
                        bCurrentSensor3 = checkBox_Sensor3.IsChecked.Value;

                        if (bCurrentSensor3 == true && bLastSensor3 == false)
                        {
                            iTimeRWait = 0;
                            bPPTBegin = true;
                            iPPTtime = 0;
                        }
                        if (bCurrentSensor3 == true)
                        {
                            iTimeRWait++;
                            if (iTimeRWait > 100)
                            {
                                iTimeRWait = 100;
                            }
                        }
                    }

                    if (checkBox_Sensor4.IsChecked.HasValue)
                    {
                        bCurrentSensor4 = checkBox_Sensor4.IsChecked.Value;

                        if (bCurrentSensor4 == true && bLastSensor4 == false)
                        {
                            iCountSensor4 = iCountSensor4 + 1;
                            if (iCountSensor4 > 10000)
                            { 
                                iCountSensor4 = 10000;
                            }
                            bPPTBegin = false;
                        }
                        else 
                        {
                            if(bPPTBegin == true)
                            {
                                iPPTtime = iPPTtime + 1;
                                if (iPPTtime > 100)
                                {  
                                    iPPTtime = 100; 
                                }
                            }
                        }
                        
                        
                    }
                }


                #region Rate calculation
                fDowntime = (float)(iTimeFWait + iTimeRWait + iTimePWait + iTimeEWait + iTimeStopWait);
                fRuntimeRate = fRuntime / (fRuntime + fDowntime);
                fRuntimeRate = fRuntimeRate * 100f;
                fDowntimeRate = 100f - fRuntimeRate;
                fUtilizeRate = (fRuntime + fDowntime) / (float)(iUtilizeRateHours*3600);
                fUtilizeRate = fUtilizeRate * 100f;
                if (iCountSensor1 != 0)
                {
                    fFPY = (float)(iCountSensor4) / (float)(iCountSensor1);
                    fFPY = fFPY * 100f;
                    
                }
                else
                {
                    fFPY = 0 * 100f;
                }
                
                #endregion
            }
            catch (Exception ex)
            {
                textBox.Text = $"Error occurred: {ex.Message}";
            }

        }
        void UpdateSettingValue()
        {
            string jsonContent = "";

            var settings = new JsonSerializerSettings
            {
                MissingMemberHandling = MissingMemberHandling.Error
            };

            try
            {
                // 將 JSON 字串轉換為自訂的物件類型
                SettingFileObject = JsonConvert.DeserializeObject<SettingFileJsonObject>(jsonContent, settings) ?? new SettingFileJsonObject();

                // 從 JSON 中讀取
                comboBox_TableSelect.SelectedIndex = SettingFileObject.Selected;
                iTableIndex = comboBox_TableSelect.SelectedIndex;
            }

            catch (FileNotFoundException)
            {
                // 檔案找不到
                textBox.Text = "找不到指定的檔案";
            }
            catch (IOException ex)
            {
                // 處理檔案讀取錯誤
                textBox.Text = $"檔案讀取錯誤: {ex.Message}";
            }
            catch (JsonSerializationException ex)
            {
                // 處理 JSON 解析錯誤
                textBox.Text = $"檔案內變數名稱錯誤: {ex.Message}";
            }


        }
        void UpdateTable1()
        {

            DataTable dataTable = new DataTable("MyDataTable");
            bool bByPassRobotConnection = false;

            string? strOut = "";
            string jsonContent = "";

            try
            {
                // 讀取 JSON 檔案的內容

                var settings = new JsonSerializerSettings
                {
                    MissingMemberHandling = MissingMemberHandling.Error
                };

                switch (iTableIndex)
                {
                    case 0:
                        jsonFileCurrent = jsonFilePath1;
                        break;
                    case 1:
                        jsonFileCurrent = jsonFilePath2;
                        break;
                    case 2:
                        jsonFileCurrent = jsonFilePath3;
                        break;
                    case 3:
                        jsonFileCurrent = jsonFilePath4;
                        break;
                    case 4:
                        jsonFileCurrent = jsonFilePath5;
                        break;

                    default:
                        textBox.Text = $"Table error";
                        break;
                }
                jsonContent = File.ReadAllText(jsonFileCurrent);

                // 將 JSON 字串轉換為自訂的物件類型
                myObject = JsonConvert.DeserializeObject<MyJsonObject>(jsonContent, settings) ?? new MyJsonObject();
                label_Table.Content = myObject.Comment;

                textBox.Text = "";

                dataTable.Columns.Add("ID", typeof(int));
                dataTable.Columns.Add("Variable", typeof(string));
                dataTable.Columns.Add("Value", typeof(string));
                dataTable.Columns.Add("Address", typeof(int));
                //dataTable.Columns.Add("Type", typeof(string));
                //dataTable.Columns.Add("DI", typeof(int));

                if (ToolbarUI.VariableProvider == null) //No robot connected...
                {
                    bByPassRobotConnection = true;
                    textBox.Text = "Warning, no robot connected...";
                }

                //更新 starts reset 第18行 
                int.TryParse(myObject.Variables[18-1].StartAddress.ToString(), out int iResetAddress);
                int[] iResetValue = modbusClient.ReadHoldingRegisters(iResetAddress,1);
                iCurrentReset = iResetValue[0];
                if (iCurrentReset == 1 && iLastReset == 0)
                {
                    iFPTtime = 0;
                    iPPTtime = 0;
                    iTimeFWait = 0;
                    iTimeRWait = 0;
                    iTimePWait = 0;
                    iTimeEWait = 0;
                    fRuntime = 0;
                    iTimeStopWait = 0;
                    fRuntimeRate = 0 *100f;
                    fDowntime = 0;
                    fDowntimeRate = 0 *100f;
                    fUtilizeRate = 0 *100f;
                    sRobotErrorCode = "00000000";
                    iPassQuantity = 0;
                    iCycleQuantity = 0;
                    fYieldRate = 0 *100f;
                    iCountSensor1 = 0;
                    iCountSensor4 = 0;
                    fFPY = 0 * 100f;
                }

                if (bByPassRobotConnection == false)
                {
                    if (ToolbarUI.VariableProvider != null)
                    {
                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable1") == true) 
                        {
                            ToolbarUI.VariableProvider.GetGlobalVariableValue("g_Variable1", out strOut);
                            int.TryParse(strOut, out ig_Variable1);
                            if (ig_Variable1 > 65535)
                            {
                                ig_Variable1 = 65535;
                            }
                        }
                        else 
                        {
                            textBox_Debug.Text = $"There is no 'Variable1' in the global variables!";
                            
                        }

                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable2") == true)
                        {
                            ToolbarUI.VariableProvider.GetGlobalVariableValue("g_Variable2", out strOut);
                            int.TryParse(strOut, out ig_Variable2);
                            if (ig_Variable2 > 65535)
                            {
                                ig_Variable2 = 65535;
                            }
                        }
                        else
                        {
                            textBox_Debug.Text = $"There is no 'Variable2' in the global variables!";
                        }

                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable3") == true)
                        {
                            ToolbarUI.VariableProvider.GetGlobalVariableValue("g_Variable3", out strOut);
                            int.TryParse(strOut, out ig_Variable3);
                            if (ig_Variable3 > 65535)
                            {
                                ig_Variable3 = 65535;
                            }
                        }
                        else
                        {
                            textBox_Debug.Text = $"There is no 'Variable3' in the global variables!";
                        }

                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable4") == true)
                        {
                            ToolbarUI.VariableProvider.GetGlobalVariableValue("g_Variable4", out strOut);
                            int.TryParse(strOut, out ig_Variable4);
                            if (ig_Variable4 > 65535)
                            {
                                ig_Variable4 = 65535;
                            }
                        }
                        else
                        {
                            textBox_Debug.Text = $"There is no 'Variable4' in the global variables!";
                        }

                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable5") == true)
                        {
                            ToolbarUI.VariableProvider.GetGlobalVariableValue("g_Variable5", out strOut);
                            int.TryParse(strOut, out ig_Variable5);
                            if (ig_Variable5 > 65535)
                            {
                                ig_Variable5 = 65535;
                            }
                        }
                        else
                        {
                            textBox_Debug.Text = $"There is no 'Variable5' in the global variables!";
                        }
                        if (ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable1")==true && ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable2")==true && ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable3")==true &&  ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable4")==true &&  ToolbarUI.VariableProvider.IsGlobalVariableExist("g_Variable5")==true) 
                        {
                            textBox_Debug.Text = "";
                        }
                    }

                }

                // 遍历变量并添加到 DataTable
                for (int i = 1; i <= myObject.Variables.Length; i++)
                {
                    DataRow row = dataTable.NewRow();
                    row["ID"] = i;
                    row["Variable"] = myObject.Variables[i - 1].Name;
                    row["Address"] = myObject.Variables[i - 1].StartAddress;
                    //row["Type"] = myObject.Variables[i-1].Type;
                    //row["DI"] = myObject.Variables[i-1].DI;

                    

                    switch (i)
                    {
                        case 1: //FPT
                            row["Value"] = iFPTtime.ToString();
                            break;

                        case 2: //PPT
                            row["Value"] = iPPTtime.ToString();
                            break;

                        case 3: //FWait
                            row["Value"] = iTimeFWait.ToString();
                            break;

                        case 4: //RWait
                            row["Value"] = iTimeRWait.ToString();
                            break;

                        case 5: //PWait
                            row["Value"] = iTimePWait.ToString();
                            break;

                        case 6: //EWait
                            row["Value"] = iTimeEWait.ToString();
                            break;

                        case 7: //Runtime                          
                            row["Value"] = fRuntime.ToString("0");
                            break;

                        case 8:
                            row["Value"] = iTimeStopWait.ToString();                           
                            break;

                        case 9: //Runtime Rate
                            row["Value"] = fRuntimeRate.ToString("0");
                            break;

                        case 10: //Downtime
                            row["Value"] = fDowntime.ToString("0");
                            break;

                        case 11: //Downtime Rate
                            row["Value"] = fDowntimeRate.ToString("0");
                            break;
                        case 12:
                            row["Value"] = fUtilizeRate.ToString("0");
                            break;

                        case 13:
                            row["Value"] = ig_Variable1.ToString();
                            break;

                        case 14:
                            row["Value"] = ig_Variable2.ToString();
                            break;

                        case 15:
                            row["Value"] = ig_Variable3.ToString();
                            break;

                        case 16:
                            row["Value"] = ig_Variable4.ToString();
                            break;

                        case 17:
                            row["Value"] = ig_Variable5.ToString();
                            break;

                        case 18:
                            if( iCurrentReset== 0 || iCurrentReset== 1)
                            {
                                row["Value"] = iResetValue[0].ToString();
                            }
                            else 
                            {
                                row["Value"] = "0";
                            }
                            break;

                        case 19: //Error code :FC:04/Address 7320~7321 int32                          
                            row["Value"] = sRobotErrorCode;                         
                            break;
                            
                        case 20: //Auto Mode
                            row["Value"] = iResultOperation.ToString();
                            break;

                        case 21: //Error status
                            if(bResultError || bResultEstop )
                            {
                                row["Value"] = "1";
                            }
                            else
                            {
                                row["Value"] = "0";
                            }
                            break;

                        case 22: //Running status
                            if (bResultRun)
                            {
                                row["Value"] = "1";
                            }
                            else
                            {
                                row["Value"] = "0";
                            }
                            break;

                        case 23: //PassQuantity
                            if (ToolbarUI.VariableProvider != null)
                            {
                                if (iCurrentReset == 1 && iLastReset == 0 && bResultRun == false)
                                {                                                                 
                                    List<string[]> listOfArrays = new List<string[]>();
                                    string[] array1 = new string[] { "g_PassQuantity", "0" };
                                    listOfArrays.Add(array1);
                                    ToolbarUI.VariableProvider.ChangeGlobalVariableValue(listOfArrays);
                                    iPassQuantity = 0;                                                                                                         
                                }
                                else
                                {
                                    ToolbarUI.VariableProvider.GetGlobalVariableValue("g_PassQuantity", out strOut);
                                    int.TryParse(strOut, out iPassQuantity);
                                    if (iPassQuantity > 10000)
                                    {
                                        iPassQuantity = 10000;
                                    }
                                }
                            }                          
                            row["Value"] = iPassQuantity.ToString();
                            break;

                        case 24: //CycleQuantity
                            if (ToolbarUI.VariableProvider != null)
                            {
                                if (iCurrentReset == 1 && iLastReset == 0 && bResultRun == false)
                                {
                                    List<string[]> listOfArrays1 = new List<string[]>();
                                    string[] array1 = new string[] { "g_CycleQuantity", "0" };
                                    listOfArrays1.Add(array1);
                                    ToolbarUI.VariableProvider.ChangeGlobalVariableValue(listOfArrays1);
                                    iCycleQuantity = 0;
                                }
                                else
                                {
                                    ToolbarUI.VariableProvider.GetGlobalVariableValue("g_CycleQuantity", out strOut);
                                    int.TryParse(strOut, out iCycleQuantity);
                                    if (iCycleQuantity > 10000)
                                    {
                                        iCycleQuantity = 10000;
                                    }
                                }
                            }                       
                            row["Value"] = iCycleQuantity.ToString();
                            break;

                        case 25: //YieldRate
                            if (iCycleQuantity !=0) 
                            {
                                fYieldRate = (float)(iPassQuantity / iCycleQuantity);
                                fYieldRate = fYieldRate * 100f;
                                if (fYieldRate > 100f)
                                {
                                    fYieldRate = 100f;
                                }
                            }
                            else 
                            {
                                fYieldRate = 0 * 100f;
                            }
                            
                            row["Value"] = fYieldRate.ToString("0");
                            break;

                        case 26:
                            row["Value"] = iCountSensor1.ToString();
                            break; 

                        case 27:
                            row["Value"] = iCountSensor4.ToString();
                            break;

                        case 28:
                            row["Value"] = fFPY.ToString("0");
                           
                            break;

                        default:
                            break;

                    }
                    if (row["Value"] != DBNull.Value && row["Address"] != DBNull.Value)
                    {
                        if (i != 19 && i !=7 && i !=10)
                        {
                            if (int.TryParse(row["Value"].ToString(), out int iCurrentValue) && int.TryParse(row["Address"].ToString(), out int iCurrentAddress))
                            {
                                if ((iCurrentValue >= 0 && iCurrentValue < 65536) && (iCurrentAddress > 0 && iCurrentAddress < 10000))
                                {
                                   
                                    modbusClient.WriteSingleRegister(iCurrentAddress, iCurrentValue);
                                }
                                else
                                {

                                    //textBox.Text = "Error, value or Modbus address is out of range!";
                                }
                            }
                        }
                        else if (i!=19 )
                        {
                            if (int.TryParse(row["Value"].ToString(), out int iCurrentValue) && int.TryParse(row["Address"].ToString(), out int iCurrentAddress))
                            {
                                if ((iCurrentValue >= 0 && iCurrentValue < 86401) && (iCurrentAddress > 0 && iCurrentAddress < 10000))
                                {
                                    
                                    int[] values = new int[] { (short)(iCurrentValue >> 16), (short)(iCurrentValue & 0xFFFF) }; // 将Int32拆分为两个Int16值
                                    modbusClient.WriteMultipleRegisters(iCurrentAddress, values);
                                }
                                else
                                {

                                    //textBox.Text = "Error, value or Modbus address is out of range!";
                                }
                            }
                        }                                                             
                        else 
                        {
                            if (int.TryParse(row["Address"].ToString(), out int iCurrentAddress))
                            {
                                if (iCurrentAddress > 0 && iCurrentAddress < 10000)
                                {
                                    
                                    // Convert the string to an array of integers (ASCII values)
                                    int[] asciiValues = new int[sRobotErrorCode.Length];
                                    for (int y = 0; y < sRobotErrorCode.Length; y++)
                                    {
                                       asciiValues[y] = (int)sRobotErrorCode[y];
                                    }                                  
                                    // Write the integer array to the Modbus server starting at address 0
                                    modbusClient.WriteMultipleRegisters(iCurrentAddress, asciiValues);
                                }
                                else
                                {
                                    //textBox.Text = "Error, value or Modbus address is out of range!";
                                }
                            }
                        }
                        
                    }
                    dataTable.Rows.Add(row);

                }
                if (iCurrentReset!= 1 && iCurrentReset != 0) 
                {
                    iCurrentReset = 0;
                }
                iLastReset = iCurrentReset;
                dataGrid.CellEditEnding += DataGrid_CellEditEnding;
                dataGrid.ItemsSource = dataTable.DefaultView;
                
                
            }
            catch (FileNotFoundException)
            {
                // 檔案找不到
                textBox.Text = "找不到指定的檔案";
            }
            catch (IOException ex)
            {
                // 處理檔案讀取錯誤
                textBox.Text = $"檔案讀取錯誤: {ex.Message}";
            }
            catch (JsonSerializationException ex)
            {
                // 處理 JSON 解析錯誤
                textBox.Text = $"檔案內變數名稱錯誤: {ex.Message}";
            }
            catch (Exception ex)
            {
                textBox.Text = $"Error: {ex.Message}";
            }


        }
        void UpdateTable2()
        {
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("ID", typeof(int));
            dataTable.Columns.Add("Name", typeof(string));
            dataTable.Columns.Add("Trigger", typeof(string));
            dataTable.Columns.Add("FilterTime", typeof(int));
            dataTable.Columns.Add("DI", typeof(int));

            // 讀取 JSON 檔案的內容
            string jsonContent = File.ReadAllText(jsonFileCurrent);
            var settings = new JsonSerializerSettings
            {
                MissingMemberHandling = MissingMemberHandling.Error
            };

            // 將 JSON 字串轉換為自訂的物件類型
            myObject = JsonConvert.DeserializeObject<MyJsonObject>(jsonContent, settings) ?? new MyJsonObject();


            textBox.Text = "";


            // 遍历变量并添加到 DataTable
            for (int i = 0; i < myObject.Signal.Length; i++)
            {
                DataRow row = dataTable.NewRow();
                row["ID"] = i + 1;
                row["Name"] = myObject.Signal[i].Name;
                row["Trigger"] = myObject.Signal[i].Trigger;
                row["FilterTime"] = myObject.Signal[i].FilterTime;
                row["DI"] = myObject.Signal[i].DI;

                dataTable.Rows.Add(row);
            }

            dataGrid1.ItemsSource = dataTable.DefaultView;

        }

        #endregion

        #region Table相關
        void UpdateJsonFile(MyJsonObject myObject, DataTable dataTable)
        {
            // Update the MyJsonObject instance based on DataTable values
            for (int i = 0; i < myObject.Variables.Length; i++)
            {
                DataRow row = dataTable.Rows[i];

                if (row["Variable"] != null && row["Type"] != null)
                {
                    myObject.Variables[i].Name = row["Variable"].ToString()!;
                    myObject.Variables[i].StartAddress = Convert.ToInt32(row["Address"]);
                    myObject.Variables[i].Type = row["Type"].ToString()!;
                }



            }
            for (int j = 0; j < myObject.Signal.Length; j++)
            {
                DataRow row = dataTable.Rows[j];

                if (row["Name"] != null)
                {
                    myObject.Signal[j].Name = row["Name"].ToString()!;
                    //myObject.Signal[j].StartAddress = Convert.ToInt32(row["Address"]);
                    myObject.Signal[j].DI = Convert.ToInt32(row["DI"]);
                }



            }

            // Serialize the updated MyJsonObject instance back to JSON
            string updatedJson = JsonConvert.SerializeObject(myObject, Formatting.Indented);

            try
            {
                // Write the updated JSON string back to the file
                File.WriteAllText(jsonFilePath_Output, updatedJson);
                textBox.Text = "JSON file updated successfully!";
            }
            catch (IOException ex)
            {
                textBox.Text = $"Error writing to JSON file: {ex.Message}";
            }
        }
        void Table2_Initialization()
        {
            // 初始化下拉选单的选项
            TypeOptions = new ObservableCollection<string>
            {
                "0",
                "1",
                "2",
                "3",
                "4",
                "5",
                "6",
                "7",

                "8",
                "9",
                "10",
                "11",
                "12",
                "13",
                "14",
                "15",
            };

            // 创建 DataTable 和添加列
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("ID", typeof(int));
            dataTable.Columns.Add("Name", typeof(string));
            dataTable.Columns.Add("Trigger", typeof(string));
            dataTable.Columns.Add("FilterTime", typeof(int));
            dataTable.Columns.Add("DI", typeof(int));


            try
            {
                // 讀取 JSON 檔案的內容
                string jsonContent = File.ReadAllText(jsonFileCurrent);
                var settings = new JsonSerializerSettings
                {
                    MissingMemberHandling = MissingMemberHandling.Error
                };

                // 將 JSON 字串轉換為自訂的物件類型
                MyJsonObject myObject = JsonConvert.DeserializeObject<MyJsonObject>(jsonContent, settings) ?? new MyJsonObject();


                textBox.Text = "";


                // 遍历变量并添加到 DataTable
                for (int i = 0; i < myObject.Signal.Length; i++)
                {
                    DataRow row = dataTable.NewRow();
                    row["ID"] = i + 1;
                    row["Name"] = myObject.Signal[i].Name;
                    row["Trigger"] = myObject.Signal[i].Trigger;
                    row["FilterTime"] = myObject.Signal[i].FilterTime;
                    row["DI"] = myObject.Signal[i].DI;

                    dataTable.Rows.Add(row);
                }
                
                dataGrid1.ItemsSource = dataTable.DefaultView;

                // 添加下拉选单列
                DataGridComboBoxColumn diColumn = new DataGridComboBoxColumn
                {
                    Header = "DI",
                    SelectedValueBinding = new System.Windows.Data.Binding("DI"),
                    ItemsSource = TypeOptions,                  
                };

                // 将下拉选单列添加到 DataGrid 的列集合中
                dataGrid1.Columns.Add(diColumn);

                dataGrid1.CellEditEnding += DataGrid_CellEditEnding;

            }
            catch (FileNotFoundException)
            {
                // 檔案找不到
                textBox.Text = "找不到指定的檔案";
            }
            catch (IOException ex)
            {
                // 處理檔案讀取錯誤
                textBox.Text = $"檔案讀取錯誤: {ex.Message}";
            }
            catch (JsonSerializationException ex)
            {
                // 處理 JSON 解析錯誤
                textBox.Text = $"檔案內變數名稱錯誤: {ex.Message}";
            }

            try
            {

            }
            catch (Exception ex)
            {
                textBox.Text = $"Table errror: {ex.Message}";
            }
        }

        //DataGrid1 text can't be edit.
        private void dataGrid1_PreparingCellForEdit(object sender, DataGridPreparingCellForEditEventArgs e) 
        {
            if (e.Column is DataGridTextColumn)
            {
                e.EditingElement.IsEnabled = false;
            }
        }
        


        //Then DataGrid is editted
        private void DataGrid_CellEditEnding(object? sender, DataGridCellEditEndingEventArgs e)
        {         
            // Handle cell edit ending event
            if (e.EditAction == DataGridEditAction.Commit && e != null && sender != null)
            {
                DataGrid dataGrid2 = (DataGrid)sender!;
                DataRowView? rowView = dataGrid2.SelectedItem as DataRowView;

                // Check if rowView and EditingElement are not null before proceeding
                if (rowView != null)
                {
                    if (dataGrid2 == dataGrid)
                    {
                        // Assuming 'Address' is the column name you want to allow users to modify
                        if (e.Column.Header.Equals("Address"))
                        {
                            // Update the DataTable
                            rowView.Row["Address"] = ((TextBox)e.EditingElement).Text;

                            // Update the corresponding MyJsonObject
                            int rowIndex = (int)rowView.Row["ID"] - 1;

                            // Check if rowIndex is within the valid range
                            if (rowIndex >= 0 && rowIndex < myObject.Variables.Length)
                            {
                                myObject.Variables[rowIndex].StartAddress = int.Parse(((TextBox)e.EditingElement).Text);                              
                                // Write the updated values back to the JSON file
                                string updatedJsonContent = JsonConvert.SerializeObject(myObject, Formatting.Indented);
                                File.WriteAllText(jsonFilePath_Output, updatedJsonContent);
                            }
                            else
                            {
                                // Handle the case where rowIndex is out of bounds
                                // You may want to log an error or display a message to the user
                                textBox.Text = "Invalid rowIndex: " + rowIndex.ToString();
                            }
                        }
                    }
                    else if (dataGrid2 == dataGrid1)
                    {
                        
                        // Assuming 'DI' is the column name you want to allow users to modify 
                        
                        if (e.Column.Header.Equals("DI") && e.EditingElement is ComboBox comboBox)
                        {
                            rowView.Row["DI"] = ((ComboBox)e.EditingElement).Text;
                            
                            // Update the corresponding MyJsonObject
                            int rowIndex = (int)rowView.Row["ID"] - 1;

                            // Check if rowIndex is within the valid range
                            
                            if (rowIndex >= 0 && rowIndex < myObject.Signal.Length)
                            {
                                myObject.Signal[rowIndex].DI = (int)rowView.Row["DI"];
                                
                                // Write the updated values back to the JSON file
                                string updatedJsonContent = JsonConvert.SerializeObject(myObject, Formatting.Indented);
                                File.WriteAllText(jsonFilePath_Output, updatedJsonContent);
                                
                            }
                            else
                            {
                                // Handle the case where rowIndex is out of bounds
                                // You may want to log an error or display a message to the user
                                textBox.Text = "Invalid rowIndex: " + rowIndex.ToString();
                            }
                            
                        }
                        
                    }
                    else
                    {
                        // Handle the case where rowView or EditingElement is null
                        // You may display an error message or perform other actions
                        textBox.Text = "rowView or EditingElement is null";
                    }


                }
                
                
            }
        }

        #endregion

        #region 按鈕類相關
        private void button_Click(object sender, RoutedEventArgs e)
        {
            textBox_Debug.Text = "";
            try
            {
                // Copy the content of jsonFilePath1_Output to jsonFilePath1, overwriting the existing content
                File.Copy(jsonFilePath_Output, jsonFileCurrent, true);

                // You can also delete jsonFilePath1_Output if needed
                //File.Delete(jsonFilePath1_Output);
            }
            catch (Exception ex)
            {
                // Handle any exceptions that might occur during the file operation
                textBox.Text = $"Error copying file: {ex.Message}";
            }
            UpdateTable1();
            UpdateTable2();
        }
        private void button_Restore_Click(object sender, RoutedEventArgs e)
        {
            UpdateTable1();
            textBox_Debug.Text = ""; // J: Debug Usage
        }
        private void comboBox_TableSelect_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            iTableIndex = comboBox_TableSelect.SelectedIndex;
            UpdateTable1();
            UpdateTable2();
            SettingFileObject.Selected = iTableIndex;
            // Write the updated values back to the JSON file
            string updatedJsonContent = JsonConvert.SerializeObject(SettingFileObject, Formatting.Indented);
            File.WriteAllText(jsonSettingFile, updatedJsonContent);
            textBox.Text = "Table changed";
        }
      

        private void comboBox_HoursSelect_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            iHourIndex = comboBox_HoursSelect.SelectedIndex;           
            switch (iHourIndex)
            {
                case 0:
                    iUtilizeRateHours = 1;
                    break;
                case 1:
                    iUtilizeRateHours = 2;
                    break;
                case 2:
                    iUtilizeRateHours = 3;
                    break;
                case 3:
                    iUtilizeRateHours = 4;
                    break;
                case 4:
                    iUtilizeRateHours = 5;
                    break;
                case 5:
                    iUtilizeRateHours = 6;
                    break;
                case 6:
                    iUtilizeRateHours = 7;
                    break;
                case 7:
                    iUtilizeRateHours = 8;
                    break;
                case 8:
                    iUtilizeRateHours = 9;
                    break;
                case 9:
                    iUtilizeRateHours = 10;
                    break;
                case 10:
                    iUtilizeRateHours = 11;
                    break;
                case 11:
                    iUtilizeRateHours = 12;
                    break;
                case 12:
                    iUtilizeRateHours = 13;
                    break;
                case 13:
                    iUtilizeRateHours = 14;
                    break;
                case 14:
                    iUtilizeRateHours = 15;
                    break;
                case 15:
                    iUtilizeRateHours = 16;
                    break;
                case 16:
                    iUtilizeRateHours = 17;
                    break;
                case 17:
                    iUtilizeRateHours = 18;
                    break;
                case 18:
                    iUtilizeRateHours = 19;
                    break;
                case 19:
                    iUtilizeRateHours = 20;
                    break;
                case 20:
                    iUtilizeRateHours = 21;
                    break;
                case 21:
                    iUtilizeRateHours = 22;
                    break;
                case 22:
                    iUtilizeRateHours = 23;
                    break;
                case 23:
                    iUtilizeRateHours = 24;
                    break;

                default:
                    textBox.Text = $"UtilizeRateHours error";
                    break;
            }
            //textBox.Text = "UtilizeRateHours Changed to "+iUtilizeRateHours.ToString();






        }
        #endregion
    }
}

